Imports System.Text
Imports System.Text.RegularExpressions
Imports Microsoft.Win32

Public Class RegexCheck

    ' e_CAOnāARs[
    Public Sub Init(ByRef fm1 As Form1)
        Me.Check_ICase.Checked = fm1.Check_ICase.Checked
        Me.Check_Single.Checked = fm1.Check_Single.Checked
        Me.Check_Multiline.Checked = fm1.Check_Multiline.Checked
        Me.TextBox_Before.Text = fm1.TextBox_Before.Text
    End Sub


    ' K\
    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        Try

            ' IvV𐮗
            Dim opt As RegexOptions = RegexOptions.None

            ' p召ʂȂ
            If Check_ICase.Checked Then
                opt = opt Or RegexOptions.IgnoreCase
            End If

            ' Ps[h
            If Check_Single.Checked Then
                opt = opt Or RegexOptions.Singleline
            End If

            's[h
            If Check_Multiline.Checked Then
                opt = opt Or RegexOptions.Multiline
            End If

            ' K\̃}b`𒲂ׂ
            Dim m As Match
            m = Regex.Match(txtTargetText.Text, TextBox_Before.Text, opt)

            If (m.Success) Then
                ' }b`IԂɂ
                txtTargetText.Focus()
                txtTargetText.Select(m.Index, m.Length)
                txtTargetText.ScrollToCaret()
            Else
                MsgBox("v镔͌܂łB", MsgBoxStyle.Information, "K\`FbN")
            End If
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical, "K\`FbN")

        End Try

    End Sub

    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click
        Try

            ' IvV𐮗
            Dim opt As RegexOptions = RegexOptions.None

            ' p召ʂȂ
            If Check_ICase.Checked Then
                opt = opt Or RegexOptions.IgnoreCase
            End If

            ' Ps[h
            If Check_Single.Checked Then
                opt = opt Or RegexOptions.Singleline
            End If

            's[h
            If Check_Multiline.Checked Then
                opt = opt Or RegexOptions.Multiline
            End If

            ' J[\ʒu̐K\̃}b`𒲂ׂ
            Dim iCursorAfter = txtTargetText.SelectionStart + txtTargetText.SelectionLength

            Dim m As Match
            m = Regex.Match(txtTargetText.Text.Substring(iCursorAfter), TextBox_Before.Text, opt)

            If (m.Success) Then
                ' }b`IԂɂ
                txtTargetText.Focus()
                txtTargetText.Select(iCursorAfter + m.Index, m.Length)
                txtTargetText.ScrollToCaret()
            Else
                MsgBox("݂̃J[\ʒuňv镔͌܂łB", MsgBoxStyle.Information, "K\`FbN")
            End If

        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical, "K\`FbN")

        End Try

    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub btnHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHelp.Click
        Help.ShowHelp(Me, Form1.strHelpFileName, HelpNavigator.Topic, "_RESOURCE\HLP000006.html")
    End Sub

    Private btnSlotBtn As Button

    Private Sub btnSlot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadBefore.Click, btnSaveBefore.Click
        Dim strRegSlotName As String
        Dim strShowText As String
        Dim i As Integer

        ' ꂽ{^NameAǂݏoׂXbg擾
        btnSlotBtn = DirectCast(sender, Button)
        strRegSlotName = "SlotBefore"

        ' XbgIp̃j[ڂNA
        ContextMenuStrip1.Items.Clear()

        ' WXg猻̃Xbge擾
        Dim rKey As RegistryKey = Registry.CurrentUser.OpenSubKey(Form1.rKeyName)
        If Not rKey Is Nothing Then
            ' WXg̒l擾
            With rKey
                For i = 0 To 9
                    ' WXgǂ񂾕32𒴂ĂBFj[\p̕Ȃ̂
                    strShowText = .GetValue(strRegSlotName & i, "(None)")
                    If strShowText.Length > 32 Then
                        strShowText = strShowText.Substring(0, 32)
                    End If

                    ' ɁAsiXy[Xɒuj
                    strShowText = strShowText.Replace(vbCrLf, " ")

                    ' j[ڂƂĒǉ
                    ContextMenuStrip1.Items.Add("Slot" & i & ":" & strShowText)
                Next

                .Close()
            End With
        Else
            For i = 0 To 9
                ContextMenuStrip1.Items.Add("Slot" & i & ":(None)")
            Next
        End If

        ' ŌɃLZǉ
        ContextMenuStrip1.Items.Add("-")
        ContextMenuStrip1.Items.Add("LZ")

        ' ReLXgj[I[v
        ContextMenuStrip1.Show(Control.MousePosition)

    End Sub

    Private Sub ContextMenuStrip1_ItemClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles ContextMenuStrip1.ItemClicked
        ' Iꂽj[̐擪4 "Slot" łȂ΁ALZƌȂďI
        If Not e.ClickedItem.Text.Substring(0, 4) = "Slot" Then
            Return
        End If

        ' IꂽXbgԍ擾
        Dim intSelectedSlot As Integer = Int(e.ClickedItem.Text.Substring(4, 1))

        ' ꂽ{^NameAǂݏoׂXbg擾
        Dim strRegSlotName As String
        Dim txtTextControl As TextBox
        strRegSlotName = "SlotBefore"
        txtTextControl = TextBox_Before

        ' ǂނ̂ĤH
        If btnSlotBtn.Name = btnLoadBefore.Name Then
            ' ǂ
            Dim rKey As RegistryKey = Registry.CurrentUser.OpenSubKey(Form1.rKeyName)
            If Not rKey Is Nothing Then
                ' WXg̒l擾
                txtTextControl.Text = rKey.GetValue(strRegSlotName & intSelectedSlot, "")
                rKey.Close()
            Else
                txtTextControl.Text = ""
            End If
        Else
            ' 
            Try
                Dim rKey As RegistryKey = Registry.CurrentUser.CreateSubKey(Form1.rKeyName)
                If Not rKey Is Nothing Then
                    ' WXg̒l擾
                    rKey.SetValue(strRegSlotName & intSelectedSlot, txtTextControl.Text)
                    rKey.Close()
                End If

            Catch ex As Exception
                MsgBox("WXgւ̕ۑɎs܂B" + Environment.NewLine + Environment.NewLine + ex.ToString(), MsgBoxStyle.Exclamation, Me.Text)

            End Try

        End If

    End Sub

End Class